/* 
 * File:   Heap.h
 * Author: peter
 *
 * Created on 03. Dezember 2012, 09:20
 */

#ifndef HEAP_H
#define	HEAP_H

class Heap {
public:
    
    static void buildHeap(unsigned short int sortedIndizes[], short int moveValues[], int size) {

        // buildHeap
        for (int i=1;i<size;i++)
            moveElement(sortedIndizes, moveValues, i);
        
        // sortHeap
        for (int i=size-1;i>0;i--) {
            int tmp=sortedIndizes[i]; // erstes (größtes) Element des Heaps an die letzte Stelle des Heaps,
            sortedIndizes[i]=sortedIndizes[0]; // dh. an den sortierten Teil des Arrays vorne anfügen.
            sortedIndizes[0]=tmp;
            moveRoot(sortedIndizes, moveValues, 0,i); // Wurzel des Heaps an die richtige Stelle einordnen
        }
    };
    
    static void moveElement(unsigned short int sortedIndizes[], short int moveValues[], int i) {
        int daddy=(i-1)/2;
        if (daddy>=0) {
            if (moveValues[sortedIndizes[i]]>moveValues[sortedIndizes[daddy]]) {
                unsigned short int tmp=sortedIndizes[daddy];
                sortedIndizes[daddy]=sortedIndizes[i];
                sortedIndizes[i]=tmp;
                moveElement(sortedIndizes, moveValues, daddy);
            }            
        }    
    };
    
    static void moveRoot(unsigned short int sortedIndizes[], short int moveValues[], int i, int border) {
        int child1=2*i+1;
        int child2=2*i+2;

        if (child1<border) {
            if (moveValues[sortedIndizes[child1]]>moveValues[sortedIndizes[i]]) {
                int tmp=sortedIndizes[child1];
                sortedIndizes[child1]=sortedIndizes[i];
                sortedIndizes[i]=tmp;

                moveRoot(sortedIndizes, moveValues, child1, border);
            }
        }

        if (child2<border) {
            if (moveValues[sortedIndizes[child2]]>moveValues[sortedIndizes[i]]) {
                int tmp=sortedIndizes[child2];
                sortedIndizes[child2]=sortedIndizes[i];
                sortedIndizes[i]=tmp;

                moveRoot(sortedIndizes, moveValues, child2, border);
            }
        }

    }
    
private:

};

#endif	/* HEAP_H */

