/* 
 * File:   Timer.h
 * Author: peter
 *
 * Created on 21. Dezember 2012, 15:26
 */

#ifndef TIMER_H
#define	TIMER_H

#include <sys/time.h>
#include <sys/timeb.h>
#include "Logger.h"

using namespace std;

extern Logger logger;

class Timer {
public:
    Timer() {};

    unsigned long getTime() {
        struct timeb timebuffer;
        ftime(&timebuffer);
        return (timebuffer.time*1000)+timebuffer.millitm;
    }
    
    void resetTimer(long timeForMove, int movestogo) {
        if (timeForMove>50)
            timeForMove-=50;
        startTime=getTime();
//        if (movestogo<10)
            movestogo+=2;
        tfmlong=timeForMove/movestogo;
        endTime=startTime+tfmlong;        
        timeout=false;        
        
//        string txt;
//        txt.append(long2string(timeForMove));
//        txt.append(", ");
//        txt.append(long2string(movestogo));
//        txt.append(", ");
//        txt.append(long2string(tfmlong));
//        
//        logger.log(txt);
    }
    
    unsigned long getEndTime() {
        return endTime;
    }
       
    void stopTimer() {
        endTime=getTime();
    }
    
    bool checkTimeout() {
        timeout=(getTime()>endTime);
        return timeout;
    }
    
    bool isTimeout() {
        return timeout;
    }
    
    double getStartEndDiffSeconds() {
        return double(endTime-startTime);
    }
    
    virtual ~Timer() {};
private:
    unsigned long startTime;
    unsigned long endTime;
    unsigned long tfmlong;
    bool timeout;
};

#endif	/* TIMER_H */