#include <string>
#include <sstream>
#include <cstddef>
#include "Position.h"
#include "globals.h"

using namespace std;

int string2int(string str) {
    char const *c=str.c_str();
    int k=atoi(c);    
    return k;
}

long string2long(string str) {
    char const *c=str.c_str();
    long k=atol(c);    
    return k;    
}

string int2String(int value) {
    string s;
    stringstream out;
    out << value;
    s = out.str();
    return s;
}

string long2string(long value) {
    string s;
    stringstream out;
    out << value;
    s = out.str();
    return s;    
}

string double2String(double value) {
    string s;
    stringstream out;
    out << value;
    s = out.str();
    return s;
}

string getBoolString(bool value) {
    return (value)?"true":"false";
}

bool figOnPos(const unsigned long &figure, const int &position) {
    return ((figure & Position::BIN[position]) != 0L);
}

string nicerCmd(string command) {

    while (true) {
        int pos = command.find("\n");
        if (pos>=0) command=command.substr(0,pos)+" "+command.substr(pos+1);
        else break;
    }    
    
    while (true) {
        int pos = command.find("\\n");
        if (pos>=0) command=command.substr(0,pos)+command.substr(pos+2);
        else break;
    }

    while (true) {
        int pos = command.find("\t");
        if (pos>=0) command=command.substr(0,pos)+" "+command.substr(pos+1);
        else break;
    }    
    
    while (true) {
        int pos = command.find("\\t");
        if (pos>=0) command=command.substr(0,pos)+command.substr(pos+2);
        else break;
    }    
    
    while (true) {
        int pos = command.find("  ");
        if (pos>=0) command=command.substr(0,pos)+command.substr(pos+1);
        else break;
    }            
    
    return command;
}


void Heap::buildHeap(unsigned short int sortedIndizes[], short int moveValues[], int size) {

    // buildHeap
    for (int i=1;i<size;i++)
        moveElement(sortedIndizes, moveValues, i);

    // sortHeap
    for (int i=size-1;i>0;i--) {
        int tmp=sortedIndizes[i]; // erstes (größtes) Element des Heaps an die letzte Stelle des Heaps,
        sortedIndizes[i]=sortedIndizes[0]; // dh. an den sortierten Teil des Arrays vorne anfügen.
        sortedIndizes[0]=tmp;
        moveRoot(sortedIndizes, moveValues, 0,i); // Wurzel des Heaps an die richtige Stelle einordnen
    }
}

void Heap::moveElement(unsigned short int sortedIndizes[], short int moveValues[], int i) {
    int daddy=(i-1)/2;
    if (daddy>=0) {
        if (moveValues[sortedIndizes[i]]>moveValues[sortedIndizes[daddy]]) {
            unsigned short int tmp=sortedIndizes[daddy];
            sortedIndizes[daddy]=sortedIndizes[i];
            sortedIndizes[i]=tmp;
            moveElement(sortedIndizes, moveValues, daddy);
        }            
    }    
}

void Heap::moveRoot(unsigned short int sortedIndizes[], short int moveValues[], int i, int border) {
    int child1=2*i+1;
    int child2=2*i+2;

    if (child1<border) {
        if (moveValues[sortedIndizes[child1]]>moveValues[sortedIndizes[i]]) {
            int tmp=sortedIndizes[child1];
            sortedIndizes[child1]=sortedIndizes[i];
            sortedIndizes[i]=tmp;

            moveRoot(sortedIndizes, moveValues, child1, border);
        }
    }

    if (child2<border) {
        if (moveValues[sortedIndizes[child2]]>moveValues[sortedIndizes[i]]) {
            int tmp=sortedIndizes[child2];
            sortedIndizes[child2]=sortedIndizes[i];
            sortedIndizes[i]=tmp;

            moveRoot(sortedIndizes, moveValues, child2, border);
        }
    }

}