/* 
 * File:   globals.h
 * Author: peter
 *
 * Created on 06. Dezember 2012, 13:27
 */

#ifndef GLOBALS_H
#define	GLOBALS_H

using namespace std;

int string2int(string str);
long string2long(string str);
string int2String(int value);
string long2string(long value);
string double2String(double value);
string getBoolString(bool value);
bool figOnPos(const unsigned long &figure, const int &position);
string nicerCmd(string command);

#define CAPTURE_NONE 0
#define CAPTURE_PAWN 1
#define CAPTURE_KNIGHT 2
#define CAPTURE_BISHOP 3
#define CAPTURE_ROOK 4
#define CAPTURE_QUEEN 5
#define CAPTURE_KING 6
#define CAPTURE_MASK 15

class Heap {
public:
    static void buildHeap(unsigned short int sortedIndizes[], short int moveValues[], int size);
    static void moveElement(unsigned short int sortedIndizes[], short int moveValues[], int i);
    static void moveRoot(unsigned short int sortedIndizes[], short int moveValues[], int i, int border);
private:
};

class Logger {
public:
    Logger() {
        pFile = fopen ("magdalena-log.txt","a");
        if (pFile==NULL)
            cout << "can't write to log file" << endl;    
    };
    
    virtual ~Logger() {
        if (pFile!=NULL)
            fclose(pFile);
    };
    
    void log(string txt) {
        if (txt.size()>0 && pFile!=NULL) {
            txt.append("\n");
            fputs (txt.data(),pFile);
        }        
    }
private:
    FILE * pFile;
};

class Perftres {
public:
    Perftres(int dep) {
        depth=dep;
        for (int i=0;i<140;i++)
            perftres[i]=0;
    };
    long print_info() {
        long sum=0;

        for (int i=0;i<depth;i++) {
            cout    <<      "Depth: "       << (i+1) <<
                            " Nodes: "     << perftres[i*7] <<
                            " Captures: "  << perftres[1+i*7] <<
                            " Checks: "    << perftres[2+i*7] <<
                            " Mates: "     << perftres[3+i*7] <<
                            " E.p.: "      << perftres[4+i*7] <<
                            " Promot.:"    << perftres[5+i*7] <<
                            " Castl.:"     << perftres[6+i*7] << endl;
            sum+=perftres[i*7];
        }
        return sum;        
    };
    int getSize() {
        return 140;
    };
    long perftres[140];
    int depth;    
private:
};

#define HASHT_EXACT 1
#define HASHT_BETA 2
#define HASHT_ALPHA 3


#endif	/* GLOBALS_H */