/* 
 * File:   MoveList.h
 * Author: peter
 *
 * Created on 16. Dezember 2012, 20:06
 */

#ifndef MOVELIST_H
#define	MOVELIST_H

using namespace std;

class MoveList {
public:
    MoveList() {
        size=1024;
        rootIndex=0;
        hashKeys = new unsigned long[size];
        bestmoves = new string[size];
    };
    
    void reset() {
        rootIndex=0;
    }
    
    void addMove(unsigned long hashKey, string move) {
        hashKeys[rootIndex]=hashKey;
        bestmoves[rootIndex]=move;
        rootIndex++;
    }
    
    void setMoveAt(int index, unsigned long hashKey, string move) {
        index+=rootIndex;
        hashKeys[index]=hashKey;
        bestmoves[index]=move;
    }
    
    virtual ~MoveList() {
        delete []hashKeys;
        delete []bestmoves;
    };
    
    string getBestMoveAt(int index) {
        return bestmoves[index];
    }
    
    unsigned long getHashKeyAt(int index) {
        return hashKeys[index];
    }
    
    bool isRepetition(int depth) {
        // printGameList(depth);
        // return false;
        int pos = depth+rootIndex;
        for (int i=pos-4;i>=0;i-=4) {
            if (hashKeys[pos]==hashKeys[i]) {
                // printGameList(depth);
                return true;
            }
        }
        return false;
    }
    
    void printGameList(int depth) {
        for (int i=0;i<=depth+rootIndex;i++)
            // cout << bestmoves[i] << " ";
            cout << hashKeys[i] << " ";
        cout << endl;
    }
    
    unsigned int getNumHalfMoves() {
        return rootIndex;
    }
    
private:
    unsigned int size;
    unsigned int rootIndex;
    unsigned long *hashKeys;
    string *bestmoves;
    
};

#endif	/* MOVELIST_H */

