/* 
 * File:   Timer.h
 * Author: peter
 *
 * Created on 21. Dezember 2012, 15:26
 */

#ifndef TIMER_H
#define	TIMER_H

#include <sys/time.h>

using namespace std;

class Timer {
public:
    Timer() {
        resetTimer();
    };
    
    void resetTimer() {
        startTime=0;
        endTime=0;
        tfmlong=0;
    }
    
    void startTimer() {
        timeval tmp;
        gettimeofday(&tmp,0);
        startTime=tmp.tv_sec*1000000+tmp.tv_usec;
    }
    
    void stopTimer() {
        timeval tmp;
        gettimeofday(&tmp,0);
        endTime=tmp.tv_sec*1000000+tmp.tv_usec;
    }
    
    void setTimeForMove(long timeForMove, int movestogo) {
        double tfmd = double(timeForMove)/movestogo; // millisekunden für zug
        tfmd = tfmd*1000; // mikrosekunden für zug
        tfmlong = (unsigned long)tfmd;
    }
    
    unsigned long getTimeout() {
        return startTime+tfmlong;
    }
    
    bool isTimeout() {
        timeval tmp;
        gettimeofday(&tmp,0);
        return ((unsigned long)(tmp.tv_sec*1000000+tmp.tv_usec)>getTimeout());
    }
    
    double getStartEndDiffSeconds() {
        if (endTime && startTime && endTime>startTime)
            return double(endTime-startTime)/1000000;
        else
            return 0;
    }
    
    virtual ~Timer() {};
private:
    unsigned long startTime;
    unsigned long endTime;
    unsigned long tfmlong;
};

#endif	/* TIMER_H */

