/* 
 * Madlenka - Chess Engine for Linux
 * Copyright (C) 2012-2014 Peter Garscha
 * 
 * This File is part of Madlenka.
 * 
 * Madlenka is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Madlenka is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Madlenka. If not, see <http://www.gnu.org/licenses/>.
 */

/* 
 * File:   PositionAspiration.cpp
 * Author: peter
 * 
 * Created on 20. Februar 2014, 18:23
 */
#include <iostream>
#include <string>
#include <sstream>
#include <cstdlib>
#include <cstdint>
#include <ctime>
#include "main.h"
#include "Timer.h"
#include "PositionAspiration.h"

using namespace std;

extern Timer timer;

void PositionAspiration::go(unsigned int depth) {
    /********************************
     * Iteratives Deepening starten *
     ********************************/
    int score;
    int infinity=20000;
    sum=0;
    unsigned long sumPositions=0;
    score=negaMax(-infinity,infinity,0,1);
    string foundMove=getMoveString(bestMoveIndex);
    sumPositions+=sum;
    cout << "depth: 1, score: " << score << ", nodes: " << sum  << ", bestmove: " << foundMove << endl;
    unsigned long iterationTime=0;
    for (unsigned int currDepth=2;currDepth<=depth;currDepth++) {                
        sum=0;
        iterationTime=timer.getTime();
        
        int aspirationWindow=50;        
        int tempScore=negaMax(score-aspirationWindow,score+aspirationWindow,0,currDepth);
        if (tempScore>score-aspirationWindow && tempScore<score+aspirationWindow)
            score=tempScore;
        else
            score=negaMax(-infinity,infinity,0,currDepth);
        
        sumPositions+=sum;
        /**************************************************
         * Iteratives Deepening abbrechen, falls maximale *
         * Zeit für die Zugsuche verstrichen ist.         *
         **************************************************/
        if (timer.isTimeout() || timer.checkTimeout())
            break;                                        
        foundMove=getMoveString(bestMoveIndex);
        cout << "depth: " << currDepth << ", score: " << score << ", nodes: " << sum  << ", bestmove: " << foundMove << endl;
        /***********************************************
         * Iteratives Deepening abbrechen, falls nicht *
         * genug Zeit für eine neue Iteration.         *
         ***********************************************/
        iterationTime=timer.getTime()-iterationTime;
        if ((timer.getEndTime()-timer.getTime())<(iterationTime))
            break;
    }

    /************************************
     * Das Ergebnis der Suche ausgeben. *
     ************************************/
    timer.stopTimer();
    double seconds = timer.getStartEndDiffSeconds();
    cout << "Move: " << foundMove << endl;
    cout << "Score: " << score << endl;
    cout << "Positions: " << sumPositions << endl;
    cout << "Time: " << seconds << " seconds" << endl;
    cout << "bestmove " << foundMove << endl;
}