/* 
 * Madlenka - Chess Engine for Linux
 * Copyright (C) 2012-2014 Peter Garscha
 * 
 * This File is part of Madlenka.
 * 
 * Madlenka is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Madlenka is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Madlenka. If not, see <http://www.gnu.org/licenses/>.
 */

/* 
 * File:   PositionEvalFast.h
 * Author: peter
 *
 * Created on 20. Februar 2014, 18:32
 */

#ifndef POSITIONEVALFAST_H
#define	POSITIONEVALFAST_H

#include "Position.h"

//! Alpha-Beta-Search (negaMax) with a fast evaluation
/*!
 * This class is based on the basic position-class and contains
 * a simple alpha-beta-search with a fast evaluation-function 
 * (material count only)
*/
class PositionEvalFast : public Position {
public:
    string getName() {return "EvalFast"; };
    void go(unsigned int depth);
    
protected:
    int evaluate(bool side2move);
    
private:
    int negaMax(int alpha, int beta, int curr_depth, int depth);
};

#endif	/* POSITIONEVALFAST_H */

