/* 
 * Madlenka - Chess Engine for Linux
 * Copyright (C) 2012-2014 Peter Garscha
 * 
 * This File is part of Madlenka.
 * 
 * Madlenka is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Madlenka is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Madlenka. If not, see <http://www.gnu.org/licenses/>.
 */

/* 
 * File:   PositionEvalQuiesce.h
 * Author: peter
 *
 * Created on 20. Februar 2014, 18:23
 */

#ifndef POSITIONEVALQUIESCE_H
#define	POSITIONEVALQUIESCE_H

#include "PositionEval.h"

//! extends PositionEval with Quiescence-Search
/*!
 * This class extends the simple alpha-beta-search with a
 * quiescience search to avoid the horizont-effect.
 * The class uses the extended evaluation from the
 * PositionEval-class.
*/
class PositionEvalQuiesce : public PositionEval {
public:
    string getName() {return "EvalQuiesce"; };
    
protected:
    int quiesce(int alpha, int beta, int curr_depth);
    int negaMax(int alpha, int beta, int curr_depth, int depth);
    
private:
    
};

#endif	/* POSITIONEVAL_H */

