/* 
 * Madlenka - Chess Engine for Linux
 * Copyright (C) 2012-2014 Peter Garscha
 * 
 * This File is part of Madlenka.
 * 
 * Madlenka is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Madlenka is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Madlenka. If not, see <http://www.gnu.org/licenses/>.
 */

/* 
 * File:   PositionRandom.h
 * Author: peter
 *
 * Created on 20. Februar 2014, 18:32
 */

#ifndef POSITIONRANDOM_H
#define	POSITIONRANDOM_H

#include <stdlib.h>
#include <time.h>
#include "Position.h"

//! This game-mode chooses any random legal move.
/*!
 * This class contains no special algorithms or any evaluation.
 * It just calculates a list of all legal moves from a position
 * and chooses anyone of them randomly.
*/
class PositionRandom : public Position {
public:
    string getName() {return "Random"; };
    void go(unsigned int depth);
protected:
    bool doRandomMove();
    bool isEnd();
private:
    string randomMove();
};

#endif	/* POSITIONRANDOM_H */