/* 
 * Madlenka - Chess Engine for Linux
 * Copyright (C) 2012-2014 Peter Garscha
 * 
 * This File is part of Madlenka.
 * 
 * Madlenka is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Madlenka is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Madlenka. If not, see <http://www.gnu.org/licenses/>.
 */

/* 
 * File:   PositionRandomCatch.cpp
 * Author: peter
 * 
 * Created on 20. Februar 2014, 18:32
 */
#include <iostream>
#include <string>
#include <sstream>
#include <cstdlib>
#include <cstdint>
#include <ctime>
#include "main.h"
#include "Timer.h"
#include "PositionRandomCatch.h"

using namespace std;

extern Timer timer;

string PositionRandomCatch::randomCatchMove() {
    string moveArray[256];
    cd=0;
    doBackup();
    calcCaptures();
    int cntMoves=0;
    for (int i=0;i<mvSize[cd];i++) {
        unsigned short int ret=move_figure(mvD[cd][i][0],mvD[cd][i][1],i%4);
        onMove=!onMove;
        bool catchKing=opponent_target_bitboard2(kings[onMove]);
        onMove=!onMove;
        undoMove(mvD[cd][i][0],mvD[cd][i][1],i%4,ret);        
        if (!catchKing) {
            moveArray[cntMoves]=getMoveString(i);
            cntMoves++;
        }
    }
    if (cntMoves) {
        int randomMove=rand()%cntMoves;
        return moveArray[randomMove];
    } else
        return randomMove();
}

string PositionRandomCatch::randomMove() {
    string moveArray[256];
    cd=0;
    doBackup();
    calc_moves();
    int cntMoves=0;
    for (int i=0;i<mvSize[cd];i++) {
        unsigned short int ret=move_figure(mvD[cd][i][0],mvD[cd][i][1],i%4);
        onMove=!onMove;
        bool catchKing=opponent_target_bitboard2(kings[onMove]);
        onMove=!onMove;
        undoMove(mvD[cd][i][0],mvD[cd][i][1],i%4,ret);        
        if (!catchKing) {
            moveArray[cntMoves]=getMoveString(i);
            cntMoves++;
        }
    }
    int randomMove=rand()%cntMoves;
    return moveArray[randomMove];
}

void PositionRandomCatch::go(unsigned int depth) {
    (void)depth; // depth wird hier nicht benötigt
    srand(time(NULL));
    string foundMove=randomCatchMove();

    /************************************
     * Das Ergebnis der Suche ausgeben. *
     ************************************/
    timer.stopTimer();
    double seconds = timer.getStartEndDiffSeconds();
    cout << "Move: " << foundMove << endl;
    cout << "Time: " << seconds << " seconds" << endl;
    cout << "bestmove " << foundMove << endl;
}