/* 
 * Madlenka - Chess Engine for Linux
 * Copyright (C) 2012-2014 Peter Garscha
 * 
 * This File is part of Madlenka.
 * 
 * Madlenka is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Madlenka is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Madlenka. If not, see <http://www.gnu.org/licenses/>.
 */

/* 
 * File:   main.h
 * Author: peter
 *
 * Created on 20. Februar 2014, 16:35
 */

#ifndef MAIN_H
#define	MAIN_H

using namespace std;

int string2int(string str);
long string2long(string str);
string int2String(int value);
bool figOnPos(const unsigned long &figure, const int &position);
string nicerCmd(string command);
void initEngine();
void setPosition(string check);
void setMode(string mode);
void newPosition();
void divide(string check);
void doPerftList();
void evalgo(string check);

//! Result-Class for Performance-Test-Command
/*!
 * The Class is simply used to return the result of a
 * Performance-Test to validate the move-generator at a
 * given position.
*/
class Perftres {
public:
    Perftres(int dep) {
        depth=dep;
        for (int i=0;i<140;i++)
            perftres[i]=0;
    };
    long print_info() {
        long sum=0;

        for (int i=0;i<depth;i++) {
            cout    <<      "Depth: "       << (i+1) <<
                            " Nodes: "     << perftres[i*7] <<
                            " Captures: "  << perftres[1+i*7] <<
                            " Checks: "    << perftres[2+i*7] <<
                            " Mates: "     << perftres[3+i*7] <<
                            " E.p.: "      << perftres[4+i*7] <<
                            " Promot.:"    << perftres[5+i*7] <<
                            " Castl.:"     << perftres[6+i*7] << endl;
            sum+=perftres[i*7];
        }
        return sum;        
    };
    int getSize() {
        return 140;
    };
    long perftres[140];
    int depth;    
private:
};

#endif	/* MAIN_H */