#!/opt/lampp/bin/php
<?

$engines = array();
$winAsWhite = array();
$drawAsWhite = array();
$lossAsWhite = array();
$winAsBlack = array();
$drawAsBlack = array();
$lossAsBlack = array();

function addEngine($engine) {
  global $engines, $winAsWhite, $drawAsWhite, $lossAsWhite, $winAsBlack, $drawAsBlack, $lossAsBlack;
  if (!in_array($engine,$engines)) {
    $engines[]=$engine;
    $winAsWhite[]="0";
    $drawAsWhite[]="0";
    $lossAsWhite[]="0";
    $winAsBlack[]="0";
    $drawAsBlack[]="0";
    $lossAsBlack[]="0";
  }
}

function getEngine($contents) {
  $pos1=strpos($contents,'"')+1;
  $contents=substr($contents,$pos1);
  $pos2=strpos($contents,'"');
  $engine=substr($contents,0,$pos2);
  return $engine;
}

function getIndex($engine) {
  global $engines;
  return array_search($engine,$engines);
}


$currentWhite=-1;
$currentBlack=-1;

if (sizeof($argv)==1)
  die("Keine Datei angegeben.\n");
else {
  $filename =  $argv[1];
  if (file_exists($filename)) {
    $handle=fopen($filename,"r");
    while (!feof($handle)) {
      $contents = fgets($handle, 8192);	
      $startswith=substr($contents,0,5);
      if ($startswith=="[Whit") {
	$engine=getEngine($contents);
	addEngine($engine);
	$currentWhite=getIndex($engine);
      } else if ($startswith=="[Blac") {
	$engine=getEngine($contents);	
	addEngine($engine);
	$currentBlack=getIndex($engine);
      } else if ($startswith=="[Resu") {
	if (strpos($contents,"1-0")) {
	  $winAsWhite[$currentWhite]++;
	  $lossAsBlack[$currentBlack]++;
	} else if (strpos($contents,"0-1")) {
	  $winAsBlack[$currentBlack]++;
	  $lossAsWhite[$currentWhite]++;	
	} else if (strpos($contents,"1/2-1/2")) {
	  $drawAsBlack[$currentBlack]++;
	  $drawAsWhite[$currentWhite]++;
	}	
      }
    }
    fclose($handle);
  } else
    die("Datei existiert nicht.\n");
}


echo "\n";

foreach ($engines as $key=>$engine) {
  echo $engine . "\n==========================================\n";
  echo "Win as White:\t" . $winAsWhite[$key] . "\n";
  echo "Draw as White:\t" . $drawAsWhite[$key] . "\n";
  echo "Loss as White:\t" . $lossAsWhite[$key] . "\n";
  echo "Win as Black:\t" . $winAsBlack[$key] . "\n";
  echo "Draw as Black:\t" . $drawAsBlack[$key] . "\n";
  echo "Loss as Black:\t" . $lossAsBlack[$key] . "\n";  
  echo "\n";
}
/*
print_r($engines);
print_r($winAsWhite);
print_r($drawAsWhite);
print_r($lossAsWhite);
*/
?>
